<?php
/**
	Plugin Name: Bank Melli Iran EDD gateway
	Version: 1.1
	Description:  این افزونه درگاه بانک ملی و شبکه پرداخت الکترونیک شاپرک را به افزونه فروش فایل EDD اضافه می‌کند.
	Plugin URI: http://proappco.com/
	Author: Javad Ahshamian
	Author URI: http://proappco.com/
	License: GPLv2
	Tested up to: 4.4
**/

include "menu_setup.php";


if (!defined('ABSPATH') ) {
	echo "HAM3DA";
	exit;
}

if(class_exists("nusoap_base")== false)
{
    require_once('lib/nusoap.php');
}

@session_start();
/////------------------------------------------------
function edd_bmi_rial ($formatted, $currency, $price) {

	return $price . ' ریال';
}
add_filter( 'edd_rial_currency_filter_after', 'edd_bmi_rial', 10, 3 );
/////------------------------------------------------
function bmi_add_gateway($gateways) {
	$gateways['Melli'] = array('admin_label' => 'درگاه بانک ملی ایران', 'checkout_label' => 'بانک ملی ایران');
	return $gateways;
}
add_filter( 'edd_payment_gateways', 'bmi_add_gateway' );

function bmi_cc_form () {
	do_action( 'bmi_cc_form_action' );
}
add_filter( 'edd_Melli_cc_form', 'bmi_cc_form' );

/////-------------------------------------------------
function bmi_process_payment($purchase_data) 
{
	//error_reporting(0);
$site_title = get_bloginfo( 'name' );
$request_form1 = '<html dir=rtl>
<head>
<meta http-equiv="Content-Language" content="fa">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<title>'.$site_title.'</title>
</head>
<body>
<center>
<div  style= "border: 1px solid #CCC;font-family:Tahoma;font-size: 12; background-color:#fafafa; width:480px;">
<font color="black" size=4 px>
		<p/>
		<br/>در حال انتقال به درگاه بانکی ...<br>
		<br/>لطفاً صبور باشید ...<br>
&nbsp;</font></div>
</center>';
        global $edd_options;

		$client = new SoapClient('https://sadad.shaparak.ir/services/MerchantUtility.asmx?wsdl');
        
        		if ($client->fault) 
                {
                    edd_set_error( 'pay_00', 'P00:خطایی در اتصال پیش آمد،مجدد تلاش کنید...' );
		            edd_send_back_to_checkout('?payment-mode=' . $purchase_data['post_data']['edd-gateway']);
        			exit();
        		} 

   

	$payment_data = array( 
		'price' => $purchase_data['price'], 
		'date' => $purchase_data['date'], 
		'user_email' => $purchase_data['post_data']['edd_email'],
		'purchase_key' => $purchase_data['purchase_key'],
		'currency' => $edd_options['currency'],
		'downloads' => $purchase_data['downloads'],
		'cart_details' => $purchase_data['cart_details'],
		'user_info' => $purchase_data['user_info'],
		'status' => 'pending');
	$payment = edd_insert_payment($payment_data);
    
    
	$Melli_MerchantID = $edd_options['Melli_MerchantID'];
	$Melli_Terminal_ID = $edd_options['Melli_Terminal_ID'];
	$Melli_Password = $edd_options['Melli_Password'];
    
	if ($payment) 
    {
        $_SESSION['bmi_payment_data'] = $payment_data;
        
		$_SESSION['Melli_payment'] = $payment;
        $orderId = date('ym').date('His').$payment;
        $return = add_query_arg(array('order'=> 'Melli', 'orderId'=>$orderId), get_permalink($edd_options['success_page']));
		$amount = $purchase_data['price'];
		$localDate = date("Ymd");
		$localTime = date("His");
		$additionalData = "Purchase key: ".$purchase_data['purchase_key'];

/////////////////PAY REQUEST PART/////////////////////////
		// Call the SOAP method

		$PayResult = $client->PaymentUtility($Melli_MerchantID, $amount, $orderId, $Melli_Password, $Melli_Terminal_ID, $return);
        

///************END of PAY REQUEST***************///
// Successfull Pay Request
          if(is_array($PayResult))
          {  
                   $_SESSION['req'] = $PayResult['RequestKey']; 
                   $FormStr = $PayResult['PaymentUtilityResult'];
                   die($request_form1.$FormStr.
                          '<script type="text/javascript" language="JavaScript">
                          document.getElementById("paymentUTLfrm").submit();
                          </script></form></body></html>');
          }
          else
          {
            
			edd_update_payment_status($payment, 'failed');
			edd_insert_payment_note( $payment, 'P02: خطا در اتصال به بانک');
			edd_set_error( 'pay_02', ':P02: خطا در اتصال به بانک' );
			edd_send_back_to_checkout('?payment-mode=' . $purchase_data['post_data']['edd-gateway']);
          }                
        
	}
    else
    {
		edd_set_error( 'pay_01', 'P01:خطا در ایجاد پرداخت، لطفاً مجدداً تلاش کنید...' );
		edd_send_back_to_checkout('?payment-mode=' . $purchase_data['post_data']['edd-gateway']);
	}
}
add_action('edd_gateway_Melli', 'bmi_process_payment');

/////----------------------------------------------------
function bmi_verify()
{
	//error_reporting(0);
	global $edd_options;
     
	$Melli_MerchantID = $edd_options['Melli_MerchantID'];
	$Melli_Terminal_ID = $edd_options['Melli_Terminal_ID'];
	$Melli_Password = $edd_options['Melli_Password'];

   
	if (isset($_GET['order']) && $_GET['order'] == 'Melli' && $_SESSION['Melli_payment'] == substr($_GET["orderId"], 10)) 
    {
		  $payment = $_SESSION['Melli_payment'];
          $res_id = $_GET["orderId"]; //orderid
          
		$do_inquiry = false;
		$do_settle = false;
		$do_reversal = false;
		$do_publish = false;
        
        
        
		//Connect to WebService
                $client = new SoapClient('https://sadad.shaparak.ir/services?wsdl');
        		if ($client->fault) 
                {
        			edd_set_error( 'ver_00', 'V00:تراکنش ناموفق بود.<br>اگر وجهی از حساب شما کسر شده باشد، تا پایان روز جاری به حساب شما باز خواهد گشت.' );
        			edd_update_payment_status($_SESSION['Melli_payment'], 'failed');
        			edd_insert_payment_note( $_SESSION['Melli_payment'], 'V00:'.'<pre>خطا در تاییدیه بانک</pre>' );
        			edd_send_back_to_checkout('?payment-mode=Melli');
        		
        		} 
//////////////////VERIFY REQUEST///////////////////////
		if (!edd_is_test_mode()) 
        {
			// Call the SOAP method
            $payment_data = $_SESSION['bmi_payment_data'];
            $price = $payment_data['price'];
            
            $result = $client->CheckRequestStatusResult($res_id , $Melli_MerchantID, $Melli_Terminal_ID, $Melli_Password, $_SESSION['req'], $price);
            $array = get_object_vars($result);
            $err_msg = bmi_CheckStatus($array['FailCode']);
            
            $ResponseCode = $array['ResponseCode'];
            $RefNo = $array['RefrenceNumber'];
            $AppStatusDescription = $array['AppStatusDescription'];
            $AppStatusCode = $array['AppStatusCode'];
                    if($AppStatusCode == 0 && $AppStatusDescription == "COMMIT")
                    {
                        $TraceNo = $array['TraceNo'];
                        //واریز شد
                        $do_reversal = false;
                        $do_publish = true;
                    
                    }
                    else
                    {
        				$do_reversal = true;
                        $do_publish = false;
                    }
                      
		}
        else 
        {
			//in test mode
			$do_reversal = true;
			$do_publish = false;
		}
///*************************END of VERIFY REQUEST**///

//////////////////REVERSAL REQUEST////////////////////
		if ($do_reversal == true)
        {

    			edd_set_error( 'rev_00', 'R00:تراکنش ناموفق بود.<br>اگر وجهی از حساب شما کسر شده باشد، تا پایان روز جاری به حساب شما باز خواهد گشت.' );
    			edd_update_payment_status($_SESSION['Melli_payment'], 'failed');
    			edd_insert_payment_note( $_SESSION['Melli_payment'], 'R00:'.'<pre>'.$err_msg.'</pre>' );
    			edd_send_back_to_checkout('?payment-mode=Melli');
        }
            #echo $soapclient->debug_str;
///***************END of REVERSAL REQUEST*******************///
		if ($do_publish == true) 
        {
			// Publish Payment
            $_SESSION['bmi_TraceNo'] = $TraceNo;
			$do_publish = false;
			edd_update_payment_status($payment, 'publish');
			edd_insert_payment_note( $payment, 'شماره تراکنش:'.$TraceNo);
			echo "<script type='text/javascript'>alert('کد تراکنش خرید بانک : ".$TraceNo."');</script>";
		}
	}	
}
add_action('init', 'bmi_verify');
/////-----------------------------------------------
function bmi_add_settings ($settings) {
	$Melli_settings = array (
		array (
			'id'		=>	'Melli_settings',
			'name'		=>	'<strong>پيکربندي درگاه بانک ملی</strong><br>(در حالت آزمایشی این قسمت را تکمیل نکنید)',
			'desc'		=>	'پيکربندي درگاه بانک ملی ایران با تنظيمات فروشگاه',
			'type'		=>	'header'
		),
		array (
			'id'		=>	'Melli_MerchantID',
			'name'		=>	'شماره پذیرنده',
			'desc'		=>	'',
			'type'		=>	'text',
			'size'		=>	'medium'
		),
		array (
			'id'		=>	'Melli_Terminal_ID',
			'name'		=>	'شماره ترمینال',
			'desc'		=>	'',
			'type'		=>	'text',
			'size'		=>	'medium'
		),
		array (
			'id'		=>	'Melli_Password',
			'name'		=>	'رمز عبور',
			'desc'		=>	'',
			'type'		=>	'text',
			'size'		=>	'medium'
		)
	);
	return array_merge( $settings, $Melli_settings );
}
add_filter('edd_settings_gateways', 'bmi_add_settings');
/////-------------------------------------------------
function bmi_CheckStatus($ErrorCode) {
	$tmess="شرح خطا: ";
$ErrorDesc =  $ErrorCode;
    if($ErrorCode=="0")
    	$ErrorDesc = "بدون اشكال";
	if($ErrorCode=="1")
		$ErrorDesc = "با بانک ملی تماس حا صل نمایید";
	else if($ErrorCode=="12")
		$ErrorDesc = "تراکنش معتبر نمی باشد";
	else if($ErrorCode=="13")
		$ErrorDesc = "مبلغ تراکنش معتبر نمی باشد";
	else if($ErrorCode=="30")
		$ErrorDesc = "فرمت پيام دچار اشكال مي باشد";
	else if($ErrorCode=="33")
		$ErrorDesc = "تاریخ استفاده کارت به پایان رسیده است";
	else if($ErrorCode=="41")
		$ErrorDesc = "كارت مفقود مي باشد";
	else if($ErrorCode=="43")
		$ErrorDesc = "كارت مسروقه است";
	else if($ErrorCode=="51")
		$ErrorDesc = "موجودي حساب كافي نمي باشد";
	else if($ErrorCode=="55")
		$ErrorDesc = "رمز وارده صحيح نمي باشد";
	else if($ErrorCode=="56")
		$ErrorDesc = "شماره کارت یا CVV2  صحیح نمی باشد ";
	else if($ErrorCode=="57")
		$ErrorDesc = "دارنده کارت مجاز به انجام این تراکنش نمی باشد";
	else if($ErrorCode=="58")
		$ErrorDesc = "پذیرنده کارت مجاز به انجام این تراکنش نمی باشد";
	else if($ErrorCode=="61")
		$ErrorDesc = "مبلغ تراکنش از حد مجاز بالاتر است";
	else if($ErrorCode=="65")
		$ErrorDesc = "تعداد دفعات تراکنش از حد مجاز بیشتر است";
	else if($ErrorCode=="75")
		$ErrorDesc = "ورود رمز دوم از حد مجاز گذشته است. رمز دوم جدید در خواست نمایید";		
	else if($ErrorCode=="79")
		$ErrorDesc = "شماره حساب نامعتبر است";
	else if($ErrorCode=="80")
		$ErrorDesc = "تراكنش موفق عمل نكرده است";
	else if($ErrorCode=="84")
		$ErrorDesc = "سوئيچ صادركننده فعال نيست";
	else if($ErrorCode=="88")
		$ErrorDesc = "سيستم دچار اشكال شده است";
	else if($ErrorCode=="90")
		$ErrorDesc = "ارتباط به طور موقت قطع می باشد";
	else if($ErrorCode=="91")
		$ErrorDesc = "پاسخ در زمان تعیین شده بدست سیستم نرسیده است";
	else if($ErrorCode=="-1")
		$ErrorDesc = "یکی از موارد مبلغ، شماره سفارش یا کلید اشتباه است";
	else if($ErrorCode=="1003")
		$ErrorDesc = "اطلاعات پذیرنده اشتباه است";
	else if($ErrorCode=="1004")
		$ErrorDesc = "پذیرنده موجود نیست";
	else if($ErrorCode=="1006")
		$ErrorDesc = "خطای داخلی";
	else if($ErrorCode=="1012")
		$ErrorDesc = "اطلاعات پذیرنده اشتباه است";
	else if($ErrorCode=="1017")
		$ErrorDesc = "پاسخ خطا از سمت مرکز";
	else if($ErrorCode=="1018")
		$ErrorDesc = "شماره کارت اشتباه است";
	else if($ErrorCode=="1019")
		$ErrorDesc = "مبلغ بیش از حد مجاز است";
	else if($ErrorCode=="9005")
		$ErrorDesc = "تراکنش ناموفق ( مبلغ به حساب دارنده کارت برگشت داده شده است)";
 	else if($ErrorCode=="9006")
		$ErrorDesc = "تراکنش ناتمام ( در صورت کسرموجودی مبلغ به حساب دارنده کارت برگشت داده می شود)";
    return $tmess.$ErrorDesc;
}
?>